1 # Executing Actions. -*- Autotest -*-
2 # Copyright (C) 2002, 2004-2005, 2007, 2009-2010 Free Software
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 3 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see <http://www.gnu.org/licenses/>.
18 AT_BANNER([[User Actions.]])
21 # AT_SYNCLINES_COMPILE(FILE)
22 # --------------------------
23 # Compile FILE expecting an error, and save in the file stdout the
24 # normalized output. Ignore the exit status, since some compilers
25 # (e.g. c89 on IRIX 6.5) triger warnings on `#error', instead of
27 m4_define([AT_SYNCLINES_COMPILE],
28 [AT_CHECK([$CC $CFLAGS $CPPFLAGS -c $1], [ignore], [], [stderr])
29 # In case GCC displays column information, strip it down.
31 # input.y:4:2: #error "4" or
32 # input.y:4.2: #error "4" or
33 # input.y:4:2: error: #error "4"
35 # input.y:4: #error "4"
37 AT_CHECK([[sed -e 's/^\([^:]*:[^:.]*\)[.:][^:]*:\(.*\)$/\1:\2/' -e 's/^\([^:]*:[^:]*:\)[^@%:@]*\( @%:@error\)/\1\2/' stderr]], 0, [stdout])
40 # AT_TEST_SYNCLINE(TITLE, INPUT, ERROR-MSG)
41 # -----------------------------------------
42 # Check that compiling the parser produced from INPUT cause GCC
44 m4_define([AT_TEST_SYNCLINE],
47 # It seems impossible to find a generic scheme to check the location
48 # of an error. Even requiring GCC is not sufficient, since for instance
49 # the version modified by Apple:
51 # | Reading specs from /usr/libexec/gcc/darwin/ppc/2.95.2/specs
52 # | Apple Computer, Inc. version gcc-934.3, based on gcc version 2.95.2
53 # | 19991024 (release) configure:2124: $? = 0
57 # | input.y:2: #error "2"
62 # | cpp-precomp: warning: errors during smart preprocessing, retrying in basic mode
68 AT_SYNCLINES_COMPILE([syncline.c])
69 AT_CHECK([[test "`cat stdout`" = 'syncline.c:1: @%:@error "1"' || exit 77]])
71 AT_DATA([[input.y]], [$2])
72 AT_BISON_CHECK([-o input.c input.y])
73 AT_SYNCLINES_COMPILE([input.c])
74 AT_CHECK([cat stdout], 0, [$3])
79 ## --------------------- ##
80 ## Prologue synch line. ##
81 ## --------------------- ##
84 AT_TEST_SYNCLINE([Prologue synch line],
87 void yyerror (const char *s);
93 [input.y:2: #error "2"
97 ## ------------------- ##
98 ## %union synch line. ##
99 ## ------------------- ##
101 AT_TEST_SYNCLINE([%union synch line],
107 void yyerror (const char *s);
113 [input.y:2: #error "2"
117 ## ------------------------- ##
118 ## Postprologue synch line. ##
119 ## ------------------------- ##
121 AT_TEST_SYNCLINE([Postprologue synch line],
123 void yyerror (const char *s);
136 [input.y:10: #error "10"
140 ## ------------------- ##
141 ## Action synch line. ##
142 ## ------------------- ##
144 AT_TEST_SYNCLINE([Action synch line],
146 void yyerror (const char *s);
155 [input.y:8: #error "8"
159 ## --------------------- ##
160 ## Epilogue synch line. ##
161 ## --------------------- ##
163 AT_TEST_SYNCLINE([Epilogue synch line],
165 void yyerror (const char *s);
173 [input.y:8: #error "8"